﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace hDialWPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void drawDial_Click(object sender, RoutedEventArgs e)
        {
            // this is where we come when DRAW is clicked
            // in Windows Form Application we used:    this.BackColor = Color.Yellow;
            // In WPF (Windows Presentation Foundation) we use:
            this.Background = Brushes.Yellow;
            // http://stackoverflow.com/questions/979876/set-background-color-of-wpf-textbox-in-c-sharp-code

            // get lat and lng and calculate hla
            double dHLA, corrM;
            string lLat = "23.456";
            
            double dLAT, dLNG, dHOUR, sLat;
            // string sLAT, sLNG, sHOUR;

            dLAT = Convert.ToDouble(this.lat.Text);  // Get the data
            dLNG = Convert.ToDouble(this.lng.Text);
            sLat = Math.Sin(dLAT * 2 * 3.1416 / 360);

            corrM = 4 * Convert.ToDouble(this.lng.Text);
            corrM = Math.Round(corrM, 2, MidpointRounding.ToEven);
            // the following works but is not displayed as the graph trashes the window
               this.corr.Content = Convert.ToString(corrM);
               this.corrNote.Content = "Minutes";

            double radius = 300.0;

            // do not use "stackpanel" as it does what it says, stacks graphical images
            // do use "canvas" http://www.c-sharpcorner.com/uploadfile/mahesh/canvas-in-wpf/
            Canvas myCan = new Canvas(); 

            for (int hr = -5; hr <= 5; hr++)
            {
                dHOUR = hr - (corrM / 60);
                dHLA  = Math.Atan(sLat * Math.Tan(15 * dHOUR * 2 * 3.1416 / 360));
                dHLA  = 360 * dHLA / (2 * 3.1416);  // dHLA is now in degrees
                dHLA  = Math.Round(dHLA, 3, MidpointRounding.ToEven);

                if (hr == 0)
                {   // at noon state the noon hour line angle
                    // the following works but is not displayed as graph trashes it
                    this.noonName.Content = "Noon hla:";
                    this.noonHla.Content = Convert.ToString(dHLA);
                }

                // http://msdn.microsoft.com/en-us/library/ms747393(v=vs.110).aspx
                // hla.Text = sHLA;               // Put the data

                // Add a Line Element
                // NOTE: the web page's example differs on this line
                Line    myLine = new Line();      
                Label   myHr   = new Label();
                Label   myHla  = new Label(); 
                myLine.Stroke = System.Windows.Media.Brushes.Blue;
                myLine.X1 = 400;                  // dial center
                myLine.Y1 = 400;

                // NOTE: X2 is a displacement from X1, and ditto Y2
                myLine.X2 = myLine.X1+(int)(radius * Math.Sin(dHLA * 2 * 3.1416 / 360));
                myLine.Y2 = myLine.Y1-(int)(radius * Math.Cos(dHLA * 2 * 3.1416 / 360));
                myLine.StrokeThickness = 1;

                myHr.Content = Convert.ToString(hr+12);
                    Canvas.SetLeft(myHr, myLine.X2-10);
                    Canvas.SetTop (myHr, myLine.Y2-25);

                myHla.Content = Convert.ToString(Math.Round(dHLA, 2, MidpointRounding.ToEven)); 
                    Canvas.SetLeft(myHla, myLine.X2 - 10);
                    Canvas.SetTop (myHla, myLine.Y2 - 45);    

                Ellipse dot = new Ellipse();
                    dot.Height = 5;    dot.Width  = 5;    dot.StrokeThickness = 1;
                    dot.Stroke = System.Windows.Media.Brushes.Blue;
                    Canvas.SetLeft(dot, myLine.X2);
                    Canvas.SetTop (dot, myLine.Y2);
                
                myCan.Children.Add(myLine);
                myCan.Children.Add(myHr);
                myCan.Children.Add(myHla); 
                myCan.Children.Add(dot); 
            }

            Label details = new Label();
            Canvas.SetLeft(details, 120);
            Canvas.SetTop (details, 450);
            details.Content = this.lat.Text;    
            myCan.Children.Add(details);

            Label offset = new Label();
            Canvas.SetLeft(offset, 220);
            Canvas.SetTop(offset, 450);
            offset.Content = this.lng.Text;
            myCan.Children.Add(offset);

            Label who = new Label();
            Canvas.SetLeft(who, 320);
            Canvas.SetTop(who, 450);
            who.Content = "horizontal dial: www.illustratingshadows.com  Feb 7, 2014";
            myCan.Children.Add(who);

            this.Content = myCan;
        }
    }
}
